package com.jenny.advancedarrows.entities;

import com.jenny.advancedarrows.config.ConfigClient;
import com.jenny.advancedarrows.items.items;

import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.EntityHitResult;
import net.minecraft.world.phys.Vec3;

import org.jetbrains.annotations.NotNull;

public class sharpenedArrow extends baseArrow{
    public sharpenedArrow(EntityType<sharpenedArrow> pEntityType, Level pLevel) {
        super(pEntityType, pLevel);
    }

    public sharpenedArrow(Level pLevel, LivingEntity pShooter) {
        super(pLevel, pShooter, entities.ARROW_SHARPENED.get());
    }

    @Override
    protected void onHitEntity(@NotNull EntityHitResult pTarget) {
        super.onHitEntity(pTarget);
        System.out.println("a");
        Entity entity1 = this.getOwner();
        Entity target = pTarget.getEntity();
        DamageSource damagesource;
        if (entity1 == null) {
            damagesource = this.damageSources().arrow(this, this);
        } else {
            damagesource = this.damageSources().arrow(this, entity1);
            if (entity1 instanceof LivingEntity) {
                ((LivingEntity)entity1).setLastHurtMob(target);
            }
        }
        target.hurt(damagesource, 5);
    }

    @NotNull
    protected ItemStack getPickupItem() {
        return new ItemStack(items.ARROW_SHARPENED.get());
    }

    @Override
    public void spawnParticles() {
        for (int i = 1; i <= ConfigClient.calcPCount(5); i++) {
            Vec3 pos = createParticlePos(1f);
            level().addParticle(ParticleTypes.END_ROD, pos.x, pos.y, pos.z, 0, 0, 0);
        }
    }
}
